Index: trunk/templates/grpman.tmpl
===================================================================
--- trunk/templates/grpman.tmpl	(revision 23)
+++ trunk/templates/grpman.tmpl	(revision 38)
@@ -10,45 +10,45 @@
 
 <table width="98%">
-<tr><td colspan=3 align=center><span class="pgtitle">Manage groups</span></td></tr>
+<tr><td colspan="3" align="center"><span class="pgtitle">Manage groups</span></td></tr>
 <tr><td><TMPL_INCLUDE NAME="pgcount.tmpl"></td>
 <td>
 <TMPL_INCLUDE NAME="fpnla.tmpl">
-</td><td align=right>insert search box here</td></tr>
+</td><td align="right">insert search box here</td></tr>
 
-<tr><td colspan=3 align=center>insert letter search here</td></tr>
+<tr><td colspan="3" align="center">insert letter search here</td></tr>
 
-<tr><td colspan=3 align=right><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&page=newgrp">New Group</a></td></tr>
+<tr><td colspan="3" align="right"><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&amp;page=newgrp">New Group</a></td></tr>
 </table>
 
-<table border=0 cellspacing="5" cellpadding="3">
+<table border="0" cellspacing="5" cellpadding="3">
 <tr>
 <TMPL_IF NAME=foobarbaz>
 <!-- This block to be un-TMPL_IF'ed once we care about sort order - by default, we sort by domain, ascending -->
-	<td class="underline" nowrap><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&page=domlist&offset=<TMPL_VAR NAME=offset>">Domain<TMPL_IF NAME=sortdomain>&nbsp;<img border=0 alt='<TMPL_VAR NAME=sortorder>' src="images/<TMPL_VAR NAME=sortorder>.png"></TMPL_IF></a></td>
-	<td class="underline" nowrap><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&page=domlist&offset=<TMPL_VAR NAME=offset>">Status<TMPL_IF NAME=sortstatus>&nbsp;<img border=0 alt='<TMPL_VAR NAME=sortorder>' src="images/<TMPL_VAR NAME=sortorder>.png"></TMPL_IF></a></td>
-	<td class="underline" align="center" nowrap><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&page=domlist&offset=<TMPL_VAR NAME=offset>">Group<TMPL_IF NAME=sortgroup>&nbsp;<img border=0 alt='<TMPL_VAR NAME=sortorder>' src="images/<TMPL_VAR NAME=sortorder>.png"></TMPL_IF></a></td>
-<TMPL_ELSE>
-	<td class="underline" nowrap>Group</td>
-	<td class="underline" nowrap width="5%">Parent Group</td>
-	<td class="underline" nowrap width="5%">Users</td>
-	<td class="underline" align="center" nowrap width="5%">Domains</td>
+	<td class="underline"><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&amp;page=domlist&amp;offset=<TMPL_VAR NAME=offset>">Domain<TMPL_IF NAME=sortdomain>&nbsp;<img border=0 alt='<TMPL_VAR NAME=sortorder>' src="images/<TMPL_VAR NAME=sortorder>.png"></TMPL_IF></a></td>
+	<td class="underline"><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&amp;page=domlist&amp;offset=<TMPL_VAR NAME=offset>">Status<TMPL_IF NAME=sortstatus>&nbsp;<img border=0 alt='<TMPL_VAR NAME=sortorder>' src="images/<TMPL_VAR NAME=sortorder>.png"></TMPL_IF></a></td>
+	<td class="underline" align="center"><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&amp;page=domlist&amp;offset=<TMPL_VAR NAME=offset>">Group<TMPL_IF NAME=sortgroup>&nbsp;<img border=0 alt='<TMPL_VAR NAME=sortorder>' src="images/<TMPL_VAR NAME=sortorder>.png"></TMPL_IF></a></td> <TMPL_ELSE>
+	<td class="underline">Group</td>
+	<td class="underline">Parent Group</td>
+	<td class="underline">Users</td>
+	<td class="underline" align="center">Domains</td>
 </TMPL_IF>
-	<td class="underline" width="1%">Delete</td>
+	<td class="underline">Delete</td>
 </tr>
 <TMPL_IF name=grouptable>
 <TMPL_LOOP name=grouptable>
 <tr class="row<TMPL_VAR name=bg>">
-	<td><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&page=grpman&action=chgroup&group=<TMPL_VAR NAME=groupid>"><TMPL_VAR NAME=groupname></a></td>
-	<td width="5%" nowrap><TMPL_VAR name=pgroup></td>
-	<td width="5%" nowrap><TMPL_VAR name=nusers></td>
-	<td width="5%" nowrap><TMPL_VAR name=ndomains></td>
-	<td width="1%" nowrap align=center><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&page=delgrp&id=<TMPL_VAR NAME=groupid>"><img src="images/trash2.png" border=0></a></td>
+	<td><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&amp;page=grpman&amp;action=chgroup&amp;group=<TMPL_VAR NAME=groupid>"><TMPL_VAR NAME=groupname></a></td>
+	<td><TMPL_VAR name=pgroup></td>
+	<td><TMPL_VAR name=nusers></td>
+	<td><TMPL_VAR name=ndomains></td>
+	<td align="center"><a href="dns.cgi?sid=<TMPL_VAR NAME=sid>&amp;page=delgrp&amp;id=<TMPL_VAR NAME=groupid>"><img src="images/trash2.png" alt="[ Delete ]" /></a></td>
 </tr>
 </TMPL_LOOP>
 <TMPL_ELSE>
-<tr><td colspan=5>No groups found</td></tr>
+<tr><td colspan="5">No groups found</td></tr>
 </TMPL_IF>
 </table>
 
 </td>
+</tr>
 </table>