Index: trunk/templates/newuser.tmpl
===================================================================
--- trunk/templates/newuser.tmpl	(revision 38)
+++ trunk/templates/newuser.tmpl	(revision 65)
@@ -12,8 +12,8 @@
 <input type="hidden" name="newuser" value="yes" />
 
-<table class="container" width="450">
-<tr><td>
-    <table border="0" cellspacing="2" cellpadding="2" width="100%">
-<TMPL_IF add_failed>	<tr><td class="errhead" colspan="2">Error adding user <TMPL_VAR NAME=uname>: <TMPL_VAR NAME=errmsg></td></tr></TMPL_IF>
+<table border="0" cellspacing="2" cellpadding="2" width="450">
+<TMPL_IF add_failed>	<tr>
+		<td class="errhead" colspan="2">Error adding user <TMPL_VAR NAME=uname>: <TMPL_VAR NAME=errmsg></td>
+	</tr></TMPL_IF>
 	<tr class="darkrowheader"><td colspan="2" align="center">Add User</td></tr>
 
@@ -53,10 +53,75 @@
 		<td>Create as active user</td><td><input type="checkbox" name="makeactive" checked="checked" /></td>
 	</tr>
+
+	<tr>
+		<td colspan="2">
+
+<table style="border: thin solid #000000;" border="0" cellspacing="5" cellpadding="0" width="100%">
+<tr class="tableheader">
+	<td align="center" colspan="5">
+	<input type="radio" name="perms_type" value="inherit" <TMPL_IF add_failed><TMPL_IF perm_inherit>checked="checked"</TMPL_IF><TMPL_ELSE>checked="checked"</TMPL_IF>/> Inherit permissions from group
+	</td>
+</tr>
+<tr>
+	<td align="right">Group:</td>
+	<td><input type="checkbox"<TMPL_IF i_grped> checked="checked"</TMPL_IF> disabled="disabled" /> Edit</td>
+	<td><input type="checkbox"<TMPL_IF i_grpcreate> checked="checked"</TMPL_IF> disabled="disabled" /> Create</td>
+	<td><input type="checkbox"<TMPL_IF i_grpdel> checked="checked"</TMPL_IF> disabled="disabled" /> Delete</td>
+</tr>
+<tr>
+	<td align="right">User:</td>
+	<td><input type="checkbox"<TMPL_IF i_usered> checked="checked"</TMPL_IF> disabled="disabled" /> Edit</td>
+	<td><input type="checkbox"<TMPL_IF i_usercreate> checked="checked"</TMPL_IF> disabled="disabled" /> Create</td>
+	<td><input type="checkbox"<TMPL_IF i_userdel> checked="checked"</TMPL_IF> disabled="disabled" /> Delete</td>
+</tr>
+<tr>
+	<td align="right">Domain:</td>
+	<td><input type="checkbox"<TMPL_IF i_domed> checked="checked"</TMPL_IF> disabled="disabled" /> Edit</td>
+	<td><input type="checkbox"<TMPL_IF i_domcreate> checked="checked"</TMPL_IF> disabled="disabled" /> Create</td>
+	<td><input type="checkbox"<TMPL_IF i_domdel> checked="checked"</TMPL_IF> disabled="disabled" /> Delete</td>
+	<!-- td>+ Delegate</td -->
+</tr>
+<tr>
+	<td align="right">Domain Record:</td>
+	<td><input type="checkbox"<TMPL_IF i_reced> checked="checked"</TMPL_IF> disabled="disabled" /> Edit</td>
+	<td><input type="checkbox"<TMPL_IF i_reccreate> checked="checked"</TMPL_IF> disabled="disabled" /> Create</td>
+	<td><input type="checkbox"<TMPL_IF i_recdel> checked="checked"</TMPL_IF> disabled="disabled" /> Delete</td>
+	<!-- td>+ Delegate</td -->
+</tr>
+<tr>
+	<td align="right">Self:</td>
+	<td><input type="checkbox"<TMPL_IF i_edself> checked="checked"</TMPL_IF> disabled="disabled" /> Edit</td>
+</tr>
+
+<tr class="tableheader">
+	<td align="center" colspan="5">
+	<input type="radio" name="perms_type" value="clone" <TMPL_IF add_failed><TMPL_IF perm_clone> checked="checked"</TMPL_IF></TMPL_IF>/> Clone permissions from an existing user
+	</td>
+</tr>
+<tr>
+	<td align="center" colspan="5">
+	Note: Only users in the current group may be cloned<br>
+	<select name="clonesrc">
+	<option>-</option>
+	<TMPL_LOOP name=clonesrc><option value="<TMPL_VAR NAME=uid>"<TMPL_IF selected> selected</TMPL_IF>><TMPL_VAR NAME=username></option>
+	</TMPL_LOOP></select>
+	</td>
+</tr>
+<tr class="tableheader">
+	<td align="center" colspan="5">
+		<input type="radio" name="perms_type" value="custom" <TMPL_IF add_failed><TMPL_IF perm_custom> checked="checked"</TMPL_IF></TMPL_IF>/> Specify permissions
+	</td>
+</tr>
+<TMPL_INCLUDE name="permlist_enabled.tmpl">
+
+</table>
+
+		</td>
+	</tr>
+
 	<tr><td colspan="2" class="tblsubmit"><input type="submit" value="Add user" /></td></tr>
+
 <tr><td colspan="2">tmp note:  radio button select "group template" vs "clone user"?</td></tr>
     </table>
-    </td>
-</tr>
-</table>
 
 </fieldset>